-module(list_stuff).
-export([average/1, average/2]).
-export([len/1, append/2, reverse/1]).

average(X) ->
    sum(X) / len(X).
average(A, B) ->
    (A+B)/2.

sum([H|T]) ->
    H + sum(T);
sum([])    ->
    0.

len(List) ->
    len_a(List, 0).

len_a([_|T], Acc) ->
    len_a(T, Acc+1);
len_a([],    Acc) ->
    Acc.

reverse(Xs) ->
    reverse_a(Xs, []).

reverse_a([X|Xs], Acc) ->
    reverse_a(Xs, [X|Acc]);
reverse_a([],     Acc) ->
    Acc.

append(Xs, Ys) ->
    reverse_a(reverse(Xs),Ys).
